import { FormBuilder } from '@angular/forms';
import { Injectable } from '@angular/core';

import { SearchService } from 'app/search/service/search-service';
import { SearchInput } from 'app/shared/model/search-input.model';
import { SearchResultsDTO } from 'app/shared/model/search/search-results-dto.model';

// @Component({
//   templateUrl: './search.component.html',
// })
@Injectable({ providedIn: 'root' })
export class SearchComponent {
  searchForm = this.fb.group({
    fullTextSearch: [''],
    keywords: ['']
  });



  constructor(
	private searchService: SearchService, 
	private fb: FormBuilder,
	) {}




	searchChanged(): void {
		const fullTextSearch = this.searchForm.value.fullTextSearch;
		this.searchFullText(fullTextSearch);
	}
	
	search(): void {
		this.searchFullText("");
	}

	searchFullText(fullText: string): void {
		const searchInput = new SearchInput();
		searchInput.fulltextQuery = fullText;
		this.searchService.searchPageDetails(searchInput)
		      .subscribe(
			        (data: SearchResultsDTO) => {
				let hits = "";
				data.searchResult.forEach(function (hit):void {hits = hits + hit.title + ":" /* + hit.description */ + '\n   '});
				
			    alert("Success! hits = \n   " + hits );
			          }
			        ,
			        () => {alert("Search failed");}
			      );

	}


}
